Con                                    'S2 RC receive/operate

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

Var
 
Obj
    
  pwm : "s2motor_driver"
  
Pub Main | aile, elev, left, right
  
  pwm.start(4_000)         'start S2 motor driver @ 4000 hertz
  
  repeat
    aile := pulse_in(0)
    elev := pulse_in(1)
    left := elev - aile
    right := elev + aile
        
    pwm.leftrightduty(left, right)

PUB pulse_in(pin) | t0, t1                      
                                            
  waitpne(1 << pin, 1 << pin, 0)            
  waitpeq(1 << pin, 1 << pin, 0)            
  t0 := cnt                                 
  waitpne(1 << pin, 1 << pin, 0)            
  t1 := cnt                                 
  return (t1 - t0) / (clkfreq / 1_000_000) - 1500 